local function register(name, self)
	register_anything_actor(name, self)
end

local leaf_frame= Def.ActorFrame{}
for i= 1, 37 do
	leaf_frame[#leaf_frame+1]= Def.Sprite{
		Name= "actor_sf",
		LeafCommand= function(self)
			self:diffusealpha(1):xy(670, math.random(-50,400))
				:zoom((math.random() * .5) + .5) -- original: math.random(0.5,1))
				:linear(math.random(2,8)):rotationx(math.random(100,2000))
				:rotationy(math.random(100,2000)):rotationz(math.random(100,2000))
				:addx(-700):addy(math.random(100,500))
				:sleep(0):queuecommand('Leaf');
		end,
		OnCommand= cmd(hibernate,0.961;queuecommand,"Leaf"),
		Texture= "black dump.png",
	}
end

return Def.ActorFrame{
  Name= "actor_ae",
	LoadActor("../mods"),
  Def.Quad{
    Name= "actor_be",
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;diffuse,color('#000000');zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffusealpha,1;sleep,6.762;linear,1;faderight,1;cropright,1),
  },
  Def.Sprite{
    Name= "actor_ce",
    InitCommand= function(self)
			register("bg_anim", self)
		end,
    OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;diffusealpha,0.5),
    Texture= "background.png",
  },
  Def.ActorFrame{
    Name= "actor_de",
    InitCommand= function(self)
			register("misty_lake", self)
		end,
    Def.ActorFrame{
      Name= "actor_ee",
      Def.Quad{
        Name= "actor_fe",
        OnCommand= cmd(zoom,2000;diffuse,color('#000000');sleep,99999999),
      },
      Def.Sprite{
        Name= "actor_ge",
        OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;texcoordvelocity,0.01,0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT),
        Texture= "shit.png",
      },
      Def.Sprite{
        Name= "actor_he",
        InitCommand= function(self)
					register("sun", self)
				end,
        OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + -140;zoom,5),
        Texture= "light.png",
      },
      Def.Sprite{
        Name= "actor_ie",
        OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + -40;texcoordvelocity,0.02,0;zoomx,1;zoomy,1.2;croptop,0.01),
        Texture= "mountains.png",
      },
      Def.Quad{
        Name= "actor_je",
        OnCommand= cmd(hibernate,61.5;x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;zoomto,SCREEN_WIDTH,SCREEN_HEIGHT;fadebottom,1;diffusealpha,0;linear,1;diffusealpha,1;sleep,30;linear,1;diffusealpha,0),
      },
    },
    Def.ActorFrame{
      Name= "actor_ke",
      FOV= 120,
      OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 200;rotationx,-80;zoomz,1.2),
      Def.Sprite{
        Name= "actor_le",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -390;rotationz,90;texcoordvelocity,0,-0.055;zoomy,4;zoomx,32;fadeleft,0.4),
        Texture= "stage.png",
      },
      Def.Sprite{
        Name= "actor_me",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;rotationz,90;texcoordvelocity,0,-0.2;zoomy,1.1;zoomx,5;fadeleft,0.05;faderight,0.05;bob;effectperiod,7;effectmagnitude,50,0,0),
        Texture= "stg2bg.png",
      },
      Def.Sprite{
        Name= "actor_ne",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;rotationz,90;diffusealpha,0.5;texcoordvelocity,0,-0.2;zoomy,-1.1;zoomx,5;fadeleft,0.05;faderight,0.05;bob;effectperiod,5;effectmagnitude,-50,0,0),
        Texture= "stg2bg.png",
      },
    },
    Def.ActorFrame{
      Name= "actor_oe",
      FOV= 50,
      OnCommand= cmd(x,SCREEN_CENTER_X + 380;y,SCREEN_CENTER_Y + -60;zoom,0.6;sleep,37.5;linear,12.5;x,SCREEN_CENTER_X + -1020),
      Def.Sprite{
        Name= "actor_pe",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;zoomx,2;zoomy,0;sleep,38.5;queuecommand,"hello"),
        Texture= "puuro.png",
        helloCommand= cmd(bounceend,0.2;zoomx,1;zoomy,1;sleep,2;bouncebegin,0.2;zoomx,2;zoomy,0),
      },
      Def.Sprite{
        Name= "actor_qe",
        OnCommand= cmd(hibernate,39;zoom,2;rainbow;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;accelerate,2;rotationz,200;zoom,0.2;diffusealpha,0),
        Texture= "casting.png",
      },
    },
    Def.ActorFrame{
      Name= "actor_re",
      FOV= 20,
      OnCommand= cmd(x,SCREEN_CENTER_X + 580;y,SCREEN_CENTER_Y + -60;zoom,0.7;sleep,67;linear,16.8;x,SCREEN_CENTER_X + -1220),
      Def.Quad{
        Name= "actor_se",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -190;zoom,250;diffuse,color('#000000');sleep,99999999),
      },
      Def.Sprite{
        Name= "actor_te",
        OnCommand= cmd(x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -240;zoom,0.5),
        Texture= "house1.png",
      },
      Def.Sprite{
        Name= "actor_ue",
        OnCommand= cmd(x,SCREEN_CENTER_X + -315;y,SCREEN_CENTER_Y + -155;zoomx,0.27;zoomy,0.32;rotationy,180;animate,0;setstate,0;sleep,72;queuecommand,"boop"),
        Texture= "marisa 2x1.png",
        boopCommand= cmd(setstate,1;zoomx,0.32;zoomy,0.37;linear,0.2;zoomx,0.27;zoomy,0.32),
      },
      Def.Sprite{
        Name= "actor_ve",
        OnCommand= cmd(x,SCREEN_CENTER_X + -295;y,SCREEN_CENTER_Y + -190;zoom,0.2;diffusealpha,0;sleep,72.3;decelerate,0.7;diffusealpha,1;addy,30),
        Texture= "sweat.png",
      },
      Def.Sprite{
        Name= "actor_we",
        OnCommand= cmd(x,SCREEN_CENTER_X + -278;y,SCREEN_CENTER_Y + -170;zoom,0.5;sleep,70;accelerate,0.4;rotationy,-70;decelerate,0.4;rotationy,-140),
        Texture= "door.png",
      },
    },
    Def.ActorFrame{
      Name= "actor_xe",
      FOV= 120,
      OnCommand= cmd(x,SCREEN_CENTER_X + 380;y,SCREEN_CENTER_Y + 20;sleep,74.6;linear,13;x,SCREEN_CENTER_X + -1020),
      Def.Sprite{
        Name= "actor_ye",
        OnCommand= cmd(x,SCREEN_CENTER_X + -310;y,SCREEN_CENTER_Y + -390;fadetop,0.2;zoom,0.5;diffusealpha,0;sleep,77;decelerate,0.3;y,SCREEN_CENTER_Y + -350;diffusealpha,1;sleep,1;accelerate,0.2;y,SCREEN_CENTER_Y + -390;diffusealpha,0),
        Texture= "taro 2x1.png",
      },
    },
    Def.ActorFrame{
      Name= "actor_ze",
      FOV= 120,
      OnCommand= cmd(x,SCREEN_CENTER_X + 380;y,SCREEN_CENTER_Y + 0;sleep,79.5;linear,13;x,SCREEN_CENTER_X + -1020),
      Def.Sprite{
        Name= "actor_af",
        Frames= {
          {Frame= 0, Delay= 0.125},
          {Frame= 1, Delay= 0.125},
          {Frame= 2, Delay= 0.125},
          {Frame= 1, Delay= 0.125},
          {Frame= 0, Delay= 0.125},
          {Frame= 1, Delay= 0.125},
          {Frame= 3, Delay= 0.125},
          {Frame= 1, Delay= 0.125},
				},
        OnCommand= cmd(hibernate,81;x,SCREEN_CENTER_X + -310;y,SCREEN_CENTER_Y + -270;bob;effectperiod,4;effectmagnitude,0,10,0;zoomx,2;zoomy,0;bounceend,0.2;zoomx,0.6;zoomy,0.6;sleep,1.2;diffusealpha,0),
        Texture= "./ayaze_idle 4x1.png",
      },
      Def.Sprite{
        Name= "actor_bf",
        Frames= {
          {Frame= 0, Delay= 0.066},
          {Frame= 1, Delay= 0.066},
          {Frame= 2, Delay= 0.066},
          {Frame= 3, Delay= 0.066},
          {Frame= 4, Delay= 999},
				},
        OnCommand= cmd(hibernate,81;x,SCREEN_CENTER_X + -310;y,SCREEN_CENTER_Y + -270;zoom,0.6;diffusealpha,0;sleep,1.2;queuecommand,"cast"),
        Texture= "./ayaze_cast 3x2.png",
        castCommand= cmd(diffusealpha,1;setstate,0;zoom,0.7;linear,0.2;zoom,0.6;sleep,3;bouncebegin,0.3;zoomx,2;zoomy,0),
      },
      Def.Sprite{
        Name= "actor_cf",
        OnCommand= cmd(hibernate,82.2;rainbow;x,SCREEN_CENTER_X + -310;y,SCREEN_CENTER_Y + -270;accelerate,2;rotationz,200;zoom,0.2;diffusealpha,0),
        Texture= "casting.png",
      },
      Def.Sprite{
        Name= "actor_df",
        OnCommand= cmd(x,SCREEN_CENTER_X + -220;y,SCREEN_CENTER_Y + -260;zoomx,0.7;zoomy,0.8;sleep,84;linear,0.8;addx,-300;addy,-400;rotationz,720),
        Texture= "trunk.png",
      },
      Def.Sprite{
        Name= "actor_ef",
        OnCommand= cmd(x,SCREEN_CENTER_X + -220;y,SCREEN_CENTER_Y + -395;zoom,0.7;diffuse,color('#FF00AA');sleep,84;linear,0.8;addx,-300;addy,-100;rotationz,-720),
        Texture= "trees.png",
      },
      Def.Sprite{
        Name= "actor_ff",
        Frames= {
          {Frame= 0, Delay= 0.0333},
          {Frame= 1, Delay= 0.0333},
          {Frame= 2, Delay= 0.0333},
          {Frame= 3, Delay= 0.0333},
          {Frame= 4, Delay= 0.0333},
          {Frame= 5, Delay= 0.0333},
          {Frame= 6, Delay= 0.0333},
          {Frame= 7, Delay= 0.0333},
          {Frame= 8, Delay= 0.0333},
          {Frame= 9, Delay= 0.0333},
          {Frame= 10, Delay= 0.0333},
          {Frame= 11, Delay= 0.0333},
          {Frame= 12, Delay= 0.0522},
          {Frame= 13, Delay= 0.0522},
          {Frame= 14, Delay= 0.0522},
          {Frame= 15, Delay= 0.0522},
          {Frame= 16, Delay= 0.0666},
          {Frame= 17, Delay= 0.0666},
          {Frame= 18, Delay= 0.0666},
          {Frame= 19, Delay= 0.0666},
          {Frame= 20, Delay= 0.0666},
          {Frame= 21, Delay= 0.0666},
          {Frame= 22, Delay= 0.0666},
          {Frame= 23, Delay= 999},
				},
        OnCommand= cmd(hibernate,84;x,SCREEN_CENTER_X + -220;y,SCREEN_CENTER_Y + -390;zoom,2;sleep,1.3;diffusealpha,0),
        Texture= "./_explosion 8x3.png",
      },
    },
    Def.ActorFrame{
      Name= "actor_gf",
      FOV= 120,
      InitCommand= function(self) register("tree_anim", self) end,
      OnCommand= cmd(x,SCREEN_CENTER_X + 0;y,SCREEN_CENTER_Y + 0;z,-10),
      Def.Sprite{
        Name= "actor_hf",
        OnCommand= cmd(x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;queuecommand,"move"),
        Texture= "trunk.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -280;zoomx,0.8;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
      Def.Sprite{
        Name= "actor_if",
        OnCommand= cmd(x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;fadebottom,0.2;queuecommand,"move"),
        Texture= "trees.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -440;zoomx,0.8;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
      Def.Sprite{
        Name= "actor_jf",
        OnCommand= cmd(hibernate,7.25;x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;queuecommand,"move"),
        Texture= "trunk.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -280;zoomx,1;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
      Def.Sprite{
        Name= "actor_kf",
        OnCommand= cmd(hibernate,7.25;x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;fadebottom,0.2;queuecommand,"move"),
        Texture= "trees.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -440;zoomx,1;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
      Def.Sprite{
        Name= "actor_lf",
        OnCommand= cmd(hibernate,12.25;x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;queuecommand,"move"),
        Texture= "trunk.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -280;zoomx,1.2;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
      Def.Sprite{
        Name= "actor_mf",
        OnCommand= cmd(hibernate,12.25;x,SCREEN_CENTER_X + 9679;y,SCREEN_CENTER_Y + 9759;fadebottom,0.2;queuecommand,"move"),
        Texture= "trees.png",
        moveCommand= cmd(x,SCREEN_CENTER_X + 280;y,SCREEN_CENTER_Y + -440;zoomx,1.2;linear,10.5;x,SCREEN_CENTER_X + -920;sleep,0;queuecommand,"move"),
      },
    },
    Def.ActorFrame{
      Name= "actor_nf",
      FOV= 120,
      OnCommand= cmd(x,SCREEN_CENTER_X + 380;y,SCREEN_CENTER_Y + 20;sleep,63;linear,13;x,SCREEN_CENTER_X + -1020),
      Def.Sprite{
        Name= "actor_of",
        OnCommand= cmd(animate,0;setstate,0;zoom,0.4;sleep,65;queuecommand,"Stuff"),
        StuffCommand= cmd(setstate,1),
        Texture= "koishi 2x1.png",
      },
      Def.Sprite{
        Name= "actor_pf",
        OnCommand= cmd(hibernate,65;x,SCREEN_CENTER_X + -320;y,SCREEN_CENTER_Y + -360;zoomx,0.2;zoomy,0;bounceend,0.5;zoomy,0.14),
        Texture= "box.png",
      },
      Def.BitmapText{
        Name= "actor_qf",
				Font= "Common Normal",
        --Font= "_eurostile outline",--Unfortunately, no fonts with shadows or outlines exist in fallback... -Kid.
				-- Or, you could set the stroke color. -Kyz
        OnCommand= cmd(strokecolor,{0, 0, 0, 1};xy,SCREEN_CENTER_X + -320, SCREEN_CENTER_Y + -385;zoom,0.45;cropright,1;sleep,65;queuecommand,"Set"),
        SetCommand= function(self)
					
					self:settext(koishi_dialog[math.random(1,6)]);
					
					self:linear(1);
					self:cropright(0);
					
				end,
        Text= "",
      },
    },
		leaf_frame,
  },
}
